from typing import List, Dict, Optional
from aixblock_ml.model import AIxBlockMLBase


class MyModel(AIxBlockMLBase):

    def predict(self, tasks: List[Dict], context: Optional[Dict] = None, **kwargs) -> List[Dict]:
        """ 
        """
        print(f'''\
        Run prediction on {tasks}
        Received context: {context}
        Project ID: {self.project_id}
        Label config: {self.label_config}
        Parsed JSON Label config: {self.parsed_label_config}''')
        return []

    def fit(self, event, data, **kwargs):
        """

        
        """

        # use cache to retrieve the data from the previous fit() runs
        old_data = self.get('my_data')
        old_model_version = self.get('model_version')
        print(f'Old data: {old_data}')
        print(f'Old model version: {old_model_version}')

        # store new data to the cache
        self.set('my_data', 'my_new_data_value')
        self.set('model_version', 'my_new_model_version')
        print(f'New data: {self.get("my_data")}')
        print(f'New model version: {self.get("model_version")}')

        print('fit() completed successfully.')
    def action(self, project, command, collection, **kwargs):
        
        print(f"""
              project: {project},
                command: {command},
                collection: {collection},
              """)
        if command.lower() == "train":
            
            return {"message": "train completed successfully"}
    def model_trial(self, project, **kwargs):
        return super().model_trial(project, **kwargs)
    
    def download(self, project, **kwargs):
        return super().download(project, **kwargs)